package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;

	public class Enemy extends Entity 
	{
		private var _image:Image;
		private var speedY:Number = 50;
		private var killed:Boolean = false;
		
		public function Enemy() 
		{
			_image = new Image(Assets.GRAPHIC_SHIP_ENEMY);
			_image.centerOO();
			graphic = _image;
			type = "Enemy";
			mask = new Pixelmask(Assets.GRAPHIC_SHIP_ENEMY, -16, -16);
			layer = GC.LAYER_ENEMY;
		}
		
		override public function added():void
		{
			killed = false;
		}
		
		override public function update():void 
		{
			if (y < 32 && speedY < 0) speedY *= -1;
			if (y > FP.height - 32 && speedY > 0) speedY *= -1; 
			y += speedY * FP.elapsed;
			
			if (x < FP.camera.x - 100 - width) {
				destroy();
			}
			
			var _bullet:Bullet = (collide("Bullet", x, y)) as Bullet;
			if (_bullet) {
				
				killed = true;
				_bullet.destroy();
				destroy();
			}
		}
		
		public function destroy():void
		{
			if (killed) {
				GV.POINTS += 100;
				GV.CURRENT_GUI.updateScore();
				GV.PARTICLE_EMITTER.explosion(x, y);
			}
			FP.world.recycle(this);
		}
		
	}
}