package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Backdrop;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.World;
	
	public class GameWorld extends World 
	{
		
		private var cameraSpeed:Number = 50; 
		private var nextSpawn:Number = 1;
		
		public function GameWorld() 
		{
			
			GV.reset();
			
			add(GV.CURRENT_GUI);
			
			GV.PLAYER.x = 64;
			GV.PLAYER.y = 240;
			add(GV.PLAYER);
			
			add(GV.PARTICLE_EMITTER);

			var b:Backdrop = new Backdrop(Assets.GRAPHIC_STARS, true, true);
			b.scrollX = 0.4;
			b.scrollY = 0.4;
			
			var b2:Backdrop = new Backdrop(Assets.GRAPHIC_STARS2, true, true);
			b2.scrollX = 0.55;
			b2.scrollY = 0.55;
			
			var b3:Backdrop = new Backdrop(Assets.GRAPHIC_STARS3, true, true);
			b3.scrollX = 0.8;
			b3.scrollY = 0.8;
			
			var e:Entity = new Entity;
			e.graphic = new Graphiclist(b, b2, b3);
			e.layer = GC.LAYER_BACKGROUND;
			add(e);
			
		}
		
		override public function update():void
		{
			super.update();
			camera.x += cameraSpeed * FP.elapsed;
			GV.PLAYER.x += cameraSpeed * FP.elapsed;
			nextSpawn -= FP.elapsed;
			if (nextSpawn <= 0) {
				nextSpawn = 1;
				var _enemy:Enemy = create(Enemy) as Enemy;
				_enemy.x = FP.camera.x + FP.width + 100;
				_enemy.y = FP.rand(FP.height);
				add(_enemy);
			}
			
		}
		
	}
}