package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;
	import net.flashpunk.utils.Input; 
	import net.flashpunk.utils.Key;
	public class Player extends Entity 
	{
		
		private var moveSpeed:Number = 200;
		private var _image:Image;
		private var bulletDelay:Number = 0;
		
		public function Player() 
		{
			_image = new Image(Assets.GRAPHIC_SHIP_PLAYER);
			_image.centerOO();
			graphic = _image;
			type = "Player";
			mask = new Pixelmask(Assets.GRAPHIC_SHIP_PLAYER, -16, -16);
			layer = GC.LAYER_PLAYER;
		}
		
		override public function update():void
		{
			if (Input.check("right")) x += moveSpeed * FP.elapsed; 
			if (Input.check("left")) x -= moveSpeed * FP.elapsed; 
			if (Input.check("down")) y += moveSpeed * FP.elapsed; 
			if (Input.check("up")) y -= moveSpeed * FP.elapsed; 
			if (x < 32 + FP.camera.x) x = 32 + FP.camera.x;
			if (x > FP.width - 32 + FP.camera.x) x = FP.width - 32 + FP.camera.x;
			if (y < 32) y = 32 ;
			if (y > FP.height - 32) y = FP.height - 32;
			if(_image.alpha >= 1) {
				if (collide("Enemy", x, y)) {
					kill();
				}
			} else {
				_image.alpha += FP.elapsed;
			}
			
			if(bulletDelay > 0)  bulletDelay -= FP.elapsed;
			else if (Input.check("fire")) {
				bulletDelay = 0.5;
				var _bullet:Bullet = FP.world.create(Bullet) as Bullet;
				_bullet.x = x;
				_bullet.y = y;
				_bullet.setMovement(400);
				FP.world.add(_bullet);
			}
		}
		
		public function kill():void 
		{
			GV.PARTICLE_EMITTER.explosion(x, y);
			x = FP.camera.x + 32;
			y = FP.halfHeight;
			_image.alpha = 0;
			GV.LIVES--;
			GV.CURRENT_GUI.playerDeath();
			
			if (GV.LIVES < 0) FP.world = new GameOver;
			
		}
	}
}